import jp.jig.jiglet.*;

public class Map extends Jiglet {
	
	Image[] img;
	int cursor;
	int[] listCount = new int[4];
	String[][] list = new String[4][];
	int[] listTop = new int[4];
	int[] listCursor = new int[4];
	int[] listChoice = new int[4];
	String word;
	int listNum = 10;
	
	public void main() {
		setSoftLabel("I");
		img = new Image[2];
		img[0] = getImage("00.gif");
		img[1] = getImage("01.gif");
		
		list[0] = new String[20];
		list[1] = new String[]{
			"S", "kC", "X", "", "{", "Hc", "R`", "", "", "Ȗ", "Qn", "", "t", "", "_ސ","V", "xR", "ΐ", "", "R", "", "", "É", "m", "Od", "", "s", "", "", "ޗ", "a̎R", "", "", "R", "L", "R", "", "", "Q", "m", "", "", "", "F{", "啪", "{", "", ""};
		listCount[1] = list[1].length;
		list[2] = new String[]{
"ׂĂ̎", "Z", "X֔ԍ", "", "HX", "x@Ah", "̑̊A{", "a@", "{݁AewZ", "X֋", "s", "VbsO{݁A̔X", "Az[", "pفA", "VnAA", "W[{", "ցAnA", "XL[", "St", "Lv", "C", "", "_ЁA@", "όnA", "A所", "RAȂǂ̎Rn", "AglA_", "h{", "wAH", "`Aw|[g", "`AtF[", "HAʓ", "̉w", "oXA_", "K\X^h", "", "r", "ZAcn", "̑̎{"};
		listCount[2] = list[2].length;
		readHistory();
		
		clearKey();
		for (;;) {
			int key = getKey();
			if (openList == 0) {
				if (key == KEY_IAPP || key == KEY_SOFT) {
					return;
				} else if (key == KEY_UP || key == KEY_LEFT) {
					cursor = (cursor + 4 - 1) % 4;
				} else if (key == KEY_DOWN) {
					cursor = (cursor + 1) % 4;
				} else if (key == KEY_RIGHT) {
					if (cursor == 0 && listCount[0] > 0) {
						openList = 1;
						listCursor[0] = 0;
						listTop[0] = 0;
						setSoftLabel("Back");
					} else {
						cursor = (cursor + 1) % 4;
					}
				} else if (key == KEY_SELECT) {
					if (cursor == 0) {
						String s = inputText(word, TEXT_KANA);
						if (s != null && s.length() > 0) {
							word = s;
							cursor = 3;
						}
						clearKey();
					} else if (cursor == 3) {
						if (word != null && word.length() > 0) {
							addHistory(word);
							String url = "http://search.map.yahoo.co.jp/search?p=" + encodeURL(word) + "&ken_name=";
							if (listChoice[1] > 0) {
								url += encodeURL(list[1][listChoice[1]]);
							}
							url += "&kind_name=";
							if (listChoice[2] > 0) {
								url += encodeURL(list[2][listChoice[2]]);
							}
							launch(url, ENCODE_EUC, 0);
							cursor = 0;
						}
					} else {
						openList = 1;
						listCursor[cursor] = listChoice[cursor];
						if (listCursor[cursor] < listNum - 1) {
							listTop[cursor] = 0;
						} else if (listCursor[cursor] > listCount[cursor] - listNum) {
							listTop[cursor] = listCount[cursor] - listNum;
						} else {
							listTop[cursor] = listCursor[cursor] - (listNum / 2);
						}
						setSoftLabel("Back");
					}
				}
			} else {
				if (key == KEY_IAPP || key == KEY_SOFT) {
					openList = 0;
					setSoftLabel("I");
				} else if (key == KEY_UP || key == KEY_DOWN) {
					if (listCount[cursor] >= (listNum - 1) && (key == KEY_UP && listCursor[cursor] == 0 || key == KEY_DOWN && listCursor[cursor] == listCount[cursor] - 1)) {
						if (key == KEY_UP) {
							listTop[cursor] = listCount[cursor] - listNum;
							listCursor[cursor] = listCount[cursor] - 1;
						} else {
							listTop[cursor] = listCursor[cursor] = 0;
						}
					} else {
						if (key == KEY_UP) {
							if (listCount[cursor] < listNum + 1) {
								listCursor[cursor] = (listCursor[cursor] + listCount[cursor] - 1) % listCount[cursor];
							} else {
								if (listTop[cursor] > 0 && listCursor[cursor] == listTop[cursor] + 1) {
									listTop[cursor]--;
								}
								listCursor[cursor]--;
							}
						} else {
							if (listCount[cursor] < listNum + 1) {
								listCursor[cursor] = (listCursor[cursor] + 1) % listCount[cursor];
							} else {
								if (listTop[cursor] < listCount[cursor] - listNum && listCursor[cursor] == listTop[cursor] + (listNum - 2)) {
									listTop[cursor]++;
								}
								listCursor[cursor]++;
							}
						}
					}
				} else if (key == KEY_LEFT) {
					if (cursor == 0) {
						openList = 0;
						setSoftLabel("I");
					}
				} else if (key == KEY_SELECT) {
					if (cursor == 0) {
						word = list[0][listCursor[0]];
						addHistory(word);
					} else {
						listChoice[cursor] = listCursor[cursor];
					}
					openList = 0;
					setSoftLabel("I");
				}
			}
			repaint();
			sleep(30);
		}
	}
	
	int fh = 12;
	public void paint(boolean allDrawFlag) {
		if (img == null || img[0] == null || img[1] == null) {
			return;
		}
		int margin = 5;
		int dw = 230;
		int ch = fh + 5;
		int dh = margin * 4 + ch * 3;
		int sx = (DW - dw) / 2;
		//int sy = (DH - dh) / 2;
		int sy =  20;
		
		setFont(0);
		fh = getFontHeight();
		setColor(255, 255, 255);
		fillRect(0, 0, DW, DH);
		
		draw3DButton(sx, sy, dw, dh);
		int w = dw - 2 * margin;
		draw3DButton(sx + margin, sy + 3 * margin + 2 * ch, w, ch);
		if (cursor == 3) {
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
			fillRect(sx + margin + 2, sy + 3 * margin + 2 * ch + 2, w - 4, ch - 4);
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT2));
		} else {
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
		}
		drawString("", sx + margin + (w - stringWidth("@@")) / 2, sy + 3 * margin + 2 * ch + fh + 2);
		drawList(1, list[1][listChoice[1]], sx + margin, sy + 2 * margin + ch, 60);
		drawList(2, list[2][listChoice[2]], sx + 2 * margin + 60, sy + 2 * margin + ch, (dw - 3 * margin - 60));
		drawList(0, word, sx + margin, sy + margin, dw - 2 * margin);
	}
	
	int openList;
	void drawList(int n, String s, int x, int y, int w) {
		int ch = fh + 5;
		draw3DRect(x, y, w, ch);
		if (cursor == n && openList == 0) {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
			fillRect(x + 1, y + 1, w, ch);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
		} else {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
		}
		if (s != null) {
			if (stringWidth(s) > w - 4) {
				drawString(s.substring(0, getLineBreak(s, 0, s.length(), w - 4)), x + 2, y + fh + 2);
			} else {
				drawString(s, x + 2, y + fh + 2);
			}
		}
		if (listCount[n] > 0) {
			if (n == 0) {
				drawImage(img[0], x + w - 16, y + 1);
			} else {
				drawImage(img[1], x + w - 16, y + 1);
			}
		}
		if (cursor == n && openList == 1) {
			y += ch + 2;
			int h;
			if (listCount[n] > listNum) {
				h = ch * listNum;
			} else {
				h = ch * listCount[n];
			}
			setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
			fillRect(x, y, w, h);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FRAME1));
			drawLine(x, y, x + w, y);
			drawLine(x, y, x, y + h);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FRAME2));
			drawLine(x + w, y, x + w, y + h);
			drawLine(x, y + h, x + w, y + h);
			for (int i = 0; i < listNum && (listTop[n] + i) < listCount[n]; i++) {
				if (listTop[n] + i == listCursor[n]) {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
					fillRect(x + 1, y + ch * i + 1, w - 1, ch);
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				}
				if (stringWidth(list[n][listTop[n] + i]) > w - 4) {
					drawString(list[n][listTop[n] + i].substring(0, getLineBreak(list[n][listTop[n] + i], 0, list[n][listTop[n] + i].length(), w - 4)), x + 2, y + ch * i + fh + 2);
				} else {
					drawString(list[n][listTop[n] + i], x + 2, y + ch * i + fh + 2);
				}
			}
			if (listCount[n] > listNum) {
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
				fillRect(x + w - 3, y + 1, 3, h);
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
				int sch = h * listNum / listCount[n];
				int scy;
				if (listTop[n] + listNum == listCount[n]) {
					scy = y + h - sch;
				} else {
					scy = y + h * listTop[n] / listCount[n];
				}
				fillRect(x + w - 3, scy, 3, sch + 1);
			}
		}
	}
	
	void readHistory() {
		byte[] b = readSP(0, 1024);
		int idx = 0;
		listChoice[1] = 0xFF & b[idx++];
		listChoice[2] = 0xFF & b[idx++];
		listCount[0] = 0xFF & b[idx++];
		for (int i = 0; i < list[0].length; i++) {
			if (i < listCount[0]) {
				int size = 0xFF & b[idx++];
				list[0][i] = new String(b, idx, size);
				idx += size;
			} else {
				list[0][i] = null;
			}
		}
	}
	
	void writeHistory() {
		byte[] b = new byte[1024];
		int idx = 0;
		b[idx++] = (byte)listChoice[1];
		b[idx++] = (byte)listChoice[2];
		b[idx++] = (byte)listCount[0];
		for (int i = 0; i < listCount[0]; i++) {
			if (list[0][i] == null || list[0][i].length() == 0) {
				b[idx++] = 0;
			} else {
				byte[] b2 = list[0][i].getBytes();
				b[idx++] = (byte)(0xFF & b2.length);
				arraycopy(b2, 0, b, idx, b2.length);
				idx += b2.length;
			}
		}
		writeSP(0, b);
	}
	
	void addHistory(String s) {
		for (int i = 0; i < list[0].length; i++) {
			if (list[0][i] != null && list[0][i].equals(s)) {
				if (i == 0) {
					return;
				}
				String[] ss = new String[list[0].length];
				arraycopy(list[0], 0, ss, 1, i);
				arraycopy(list[0], i + 1, ss, i + 1, list[0].length - i - 1);
				ss[0] = s;
				list[0] = ss;
				writeHistory();
				return;
			}
		}
		String[] ss = new String[list[0].length];
		arraycopy(list[0], 0, ss, 1, list[0].length - 1);
		ss[0] = s;
		list[0] = ss;
		listCount[0]++;
		if (listCount[0] > list[0].length) {
			listCount[0] = list[0].length;
		}
		writeHistory();
	}
}
